/* Generated By:JavaCC: Do not edit this line. XSCParser.java */
package noown.domain.xsc;

import noown.domain.xsc.val.*;

/**
 * This class parses documents in XML Schema compact syntax.
 * Generated code from XSCParser.jj
 */
public class XSCParser implements XSCParserConstants {
        private static XSCHandler fHandler;

        /**
	 * Set the XSCHandler that will deal with the events emitted.
	 * To reuse the for another file, use ReInit
	 */
        public static void setHandler(XSCHandler handler)
        {
                fHandler = handler;
                token_source.setHandler(handler);
        }

        /**
	 * Start parsing
	 */
        public static void start() throws XSCException
        {
                if (fHandler == null)
                        throw new XSCException(XSCException.NoHandler);
                else
                {
                        try {
                                schema();
                        } catch (ParseException e)
                        {
                                XSCException parseErr = new XSCException(XSCException.ParseException,e);
                                if (e.currentToken.next != null)
                                        parseErr.setLocation( e.currentToken.next.beginLine,
                                                                                  e.currentToken.next.beginColumn);
                                else if (e.currentToken != null)
                                        parseErr.setLocation( e.currentToken.endLine,
                                                                                  e.currentToken.endColumn);

                                throw parseErr;
                        }
                        catch (TokenMgrError g)
                        {
                                XSCException lexerErr = new XSCException(XSCException.TokenMgrErr,g);
                                throw lexerErr;
                        }
                        catch (XSCException f)
                        {
                                if (token.next != null)
                                        f.setLocation( token.next.beginLine,
                                                                   token.next.beginColumn);
                                else if (token != null)
                                        f.setLocation(token.endLine,token.endColumn);
                                throw f;
                        }
                }
        }

/* ------------------------- */
/* Start of the grammar part */
/* ------------------------- */


/* This is the start symbol */
  static final public void schema() throws ParseException, XSCException {
    label_1:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case TARGET_NS:
      case NAMESPACE:
      case _DEFAULT:
      case EL_DEFAULT:
      case ATT_DEFAULT:
      case VERSION:
        ;
        break;
      default:
        jj_la1[0] = jj_gen;
        break label_1;
      }
      schemaOption();
    }
    label_2:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INCLUDE:
      case IMPORT:
      case REDEFINE:
        ;
        break;
      default:
        jj_la1[1] = jj_gen;
        break label_2;
      }
      schemaInclude();
    }
    label_3:
    while (true) {
      schemaBody();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMPLEX_TYPE:
      case SIMPLE_TYPE:
      case ELEMENT:
      case ATTRIBUTE:
      case GROUP:
      case ATT_GROUP:
      case NOTATION:
      case ABSTRACT:
      case NILLABLE:
      case QUALIFIED:
      case UNQUALIFIED:
      case FINAL:
      case FINAL_EXT:
      case FINAL_RESTR:
      case FINAL_LIST:
      case FINAL_UNION:
      case BLOCK:
      case BLOCK_SUBST:
      case BLOCK_RESTR:
      case BLOCK_EXT:
      case REQUIRED:
      case OPTIONAL:
      case PROHIBITED:
        ;
        break;
      default:
        jj_la1[2] = jj_gen;
        break label_3;
      }
    }
    jj_consume_token(0);
  }

  static final public void schemaOption() throws ParseException, XSCException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TARGET_NS:
      targetNamespace();
      break;
    case NAMESPACE:
      namespace();
      break;
    case _DEFAULT:
      blockFinalDefault();
      break;
    case EL_DEFAULT:
      elementDefault();
      break;
    case ATT_DEFAULT:
      attributeDefault();
      break;
    case VERSION:
      version();
      break;
    default:
      jj_la1[3] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  static final public void schemaInclude() throws ParseException, XSCException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INCLUDE:
      include();
      break;
    case IMPORT:
      _import();
      break;
    case REDEFINE:
      redefine();
      break;
    default:
      jj_la1[4] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  static final public void schemaBody() throws ParseException, XSCException {
    if (jj_2_1(2147483647)) {
      simpleType();
    } else if (jj_2_2(2147483647)) {
      complexType();
    } else if (jj_2_3(2147483647)) {
      element();
    } else if (jj_2_4(2147483647)) {
      attribute();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case GROUP:
        group();
        break;
      case ATT_GROUP:
        attributeGroup();
        break;
      case NOTATION:
        notation();
        break;
      default:
        jj_la1[5] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

/* -------------- */
/* Schema Options */
/* -------------- */
  static final public void targetNamespace() throws ParseException, XSCException {
  XSCURIValue u;
                                                          fHandler.startComponent(XSCParserConstants.TARGET_NS,null);
    jj_consume_token(TARGET_NS);
    u = uri();
                                          fHandler.extension(XSCParserConstants.NAMESPACE,u);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case END_COMP:
      jj_consume_token(END_COMP);
      break;
    default:
      jj_la1[6] = jj_gen;
      ;
    }
                                          fHandler.endComponent();
  }

  static final public void namespace() throws ParseException, XSCException {
  XSCNameValue n=null; XSCURIValue u;
    jj_consume_token(NAMESPACE);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case NAME_LIT:
    case NAME_ESCAPE:
      n = name();
      break;
    default:
      jj_la1[7] = jj_gen;
      ;
    }
                                    fHandler.startComponent(XSCParserConstants.NAMESPACE,n);
    u = uri();
                                                  fHandler.extension(XSCParserConstants.NAMESPACE,u);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case END_COMP:
      jj_consume_token(END_COMP);
      break;
    default:
      jj_la1[8] = jj_gen;
      ;
    }
                                          fHandler.endComponent();
  }

  static final public void blockFinalDefault() throws ParseException, XSCException {
    jj_consume_token(_DEFAULT);
    qualifier();
    label_4:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SEQ:
        ;
        break;
      default:
        jj_la1[9] = jj_gen;
        break label_4;
      }
      jj_consume_token(SEQ);
      qualifier();
    }
                                                          fHandler.startComponent(XSCParserConstants._DEFAULT,null);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case END_COMP:
      jj_consume_token(END_COMP);
      break;
    default:
      jj_la1[10] = jj_gen;
      ;
    }
                                          fHandler.endComponent();
  }

  static final public void elementDefault() throws ParseException, XSCException {
    jj_consume_token(EL_DEFAULT);
    qualifier();
                                   fHandler.startComponent(XSCParserConstants.EL_DEFAULT,null);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case END_COMP:
      jj_consume_token(END_COMP);
      break;
    default:
      jj_la1[11] = jj_gen;
      ;
    }
                                          fHandler.endComponent();
  }

  static final public void attributeDefault() throws ParseException, XSCException {
    jj_consume_token(ATT_DEFAULT);
    qualifier();
                                    fHandler.startComponent(XSCParserConstants.ATT_DEFAULT,null);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case END_COMP:
      jj_consume_token(END_COMP);
      break;
    default:
      jj_la1[12] = jj_gen;
      ;
    }
                                          fHandler.endComponent();
  }

  static final public void version() throws ParseException, XSCException {
  XSCStringValue s;
    jj_consume_token(VERSION);
    s = string();
                                  fHandler.startComponent(XSCParserConstants.VERSION,null);
                                                          fHandler.extension(XSCParserConstants.VERSION,s);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case END_COMP:
      jj_consume_token(END_COMP);
      break;
    default:
      jj_la1[13] = jj_gen;
      ;
    }
                                          fHandler.endComponent();
  }

  static final public void include() throws ParseException, XSCException {
  XSCURIValue u;
    jj_consume_token(INCLUDE);
    u = uri();
                                          fHandler.startComponent(XSCParserConstants.INCLUDE,null);
                                                          fHandler.extension(XSCParserConstants.INCLUDE,u);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case END_COMP:
      jj_consume_token(END_COMP);
      break;
    default:
      jj_la1[14] = jj_gen;
      ;
    }
                                          fHandler.endComponent();
  }

  static final public void _import() throws ParseException, XSCException {
  XSCURIValue u;
    jj_consume_token(IMPORT);
    u = uri();
                                          fHandler.startComponent(XSCParserConstants.IMPORT,null);
                                                          fHandler.extension(XSCParserConstants.IMPORT,u);
    jj_consume_token(NAMESPACE);
    u = uri();
                                          fHandler.extension(XSCParserConstants.NAMESPACE,u);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case END_COMP:
      jj_consume_token(END_COMP);
      break;
    default:
      jj_la1[15] = jj_gen;
      ;
    }
                                          fHandler.endComponent();
  }

// ADD INNER REDEFINITIONS
  static final public void redefine() throws ParseException, XSCException {
  XSCURIValue u;
    jj_consume_token(REDEFINE);
    u = uri();
                                          fHandler.startComponent(XSCParserConstants.REDEFINE,null);
                                                          fHandler.extension(XSCParserConstants.REDEFINE,u);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case START_BLOCK:
      jj_consume_token(START_BLOCK);
                                          fHandler.startBlock();
      label_5:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMPLEX_TYPE:
        case SIMPLE_TYPE:
        case GROUP:
        case ATT_GROUP:
        case ABSTRACT:
        case NILLABLE:
        case QUALIFIED:
        case UNQUALIFIED:
        case FINAL:
        case FINAL_EXT:
        case FINAL_RESTR:
        case FINAL_LIST:
        case FINAL_UNION:
        case BLOCK:
        case BLOCK_SUBST:
        case BLOCK_RESTR:
        case BLOCK_EXT:
        case REQUIRED:
        case OPTIONAL:
        case PROHIBITED:
          ;
          break;
        default:
          jj_la1[16] = jj_gen;
          break label_5;
        }
        if (jj_2_5(2147483647)) {
          simpleType();
        } else if (jj_2_6(2147483647)) {
          complexType();
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case GROUP:
            group();
            break;
          case ATT_GROUP:
            attributeGroup();
            break;
          default:
            jj_la1[17] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
      }
      jj_consume_token(END_BLOCK);
                                          fHandler.endBlock();
      break;
    default:
      jj_la1[18] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case END_COMP:
      jj_consume_token(END_COMP);
      break;
    default:
      jj_la1[19] = jj_gen;
      ;
    }
                                          fHandler.endComponent();
  }

/* ----------------- */
/* Common constructs */
/* ----------------- */
  static final public void qualifier() throws ParseException, XSCException {
        Token t;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FINAL:
      t = jj_consume_token(FINAL);
      break;
    case FINAL_EXT:
      t = jj_consume_token(FINAL_EXT);
      break;
    case FINAL_RESTR:
      t = jj_consume_token(FINAL_RESTR);
      break;
    case FINAL_LIST:
      t = jj_consume_token(FINAL_LIST);
      break;
    case FINAL_UNION:
      t = jj_consume_token(FINAL_UNION);
      break;
    case BLOCK:
      t = jj_consume_token(BLOCK);
      break;
    case BLOCK_SUBST:
      t = jj_consume_token(BLOCK_SUBST);
      break;
    case BLOCK_RESTR:
      t = jj_consume_token(BLOCK_RESTR);
      break;
    case BLOCK_EXT:
      t = jj_consume_token(BLOCK_EXT);
      break;
    case QUALIFIED:
      t = jj_consume_token(QUALIFIED);
      break;
    case UNQUALIFIED:
      t = jj_consume_token(UNQUALIFIED);
      break;
    case ABSTRACT:
      t = jj_consume_token(ABSTRACT);
      break;
    case NILLABLE:
      t = jj_consume_token(NILLABLE);
      break;
    case OPTIONAL:
      t = jj_consume_token(OPTIONAL);
      break;
    case REQUIRED:
      t = jj_consume_token(REQUIRED);
      break;
    case PROHIBITED:
      t = jj_consume_token(PROHIBITED);
      break;
    default:
      jj_la1[20] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
          fHandler.qualifier(t.kind);
  }

  static final public void derivation() throws ParseException, XSCException {
  Token d;
  XSCNameValue n;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case EXTENDS:
      d = jj_consume_token(EXTENDS);
      n = name();
      break;
    case RESTRICTS:
      d = jj_consume_token(RESTRICTS);
      n = name();
      break;
    default:
      jj_la1[21] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
          fHandler.extension(d.kind,n);
  }

  static final public void substitution() throws ParseException, XSCException {
  XSCNameValue n;
    jj_consume_token(SUBSTITUTES);
    n = name();
          fHandler.extension(XSCParserConstants.SUBSTITUTES,n);
  }

  static final public void fixedDefault() throws ParseException, XSCException {
  Token d;
  XSCStringValue s;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case EQUAL:
      d = jj_consume_token(EQUAL);
      s = string();
      break;
    case SET_DEF:
      d = jj_consume_token(SET_DEF);
      s = string();
      break;
    default:
      jj_la1[22] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
          fHandler.extension(d.kind,s);
  }

/* -------------------- */
/* Structures : ELEMENT */
/* -------------------- */
  static final public void element() throws ParseException, XSCException {
  XSCNameValue n;
    label_6:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
      case NILLABLE:
      case QUALIFIED:
      case UNQUALIFIED:
      case FINAL:
      case FINAL_EXT:
      case FINAL_RESTR:
      case FINAL_LIST:
      case FINAL_UNION:
      case BLOCK:
      case BLOCK_SUBST:
      case BLOCK_RESTR:
      case BLOCK_EXT:
      case REQUIRED:
      case OPTIONAL:
      case PROHIBITED:
        ;
        break;
      default:
        jj_la1[23] = jj_gen;
        break label_6;
      }
      qualifier();
    }
    jj_consume_token(ELEMENT);
    n = name();
                                  fHandler.startComponent(XSCParserConstants.ELEMENT,n);
    label_7:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case RESTRICTS:
      case EXTENDS:
      case SUBSTITUTES:
        ;
        break;
      default:
        jj_la1[24] = jj_gen;
        break label_7;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SUBSTITUTES:
        substitution();
        break;
      case RESTRICTS:
      case EXTENDS:
        derivation();
        break;
      default:
        jj_la1[25] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case START_BLOCK:
      elementContent();
      break;
    default:
      jj_la1[26] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case EQUAL:
    case SET_DEF:
      fixedDefault();
      break;
    default:
      jj_la1[27] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case END_COMP:
      jj_consume_token(END_COMP);
      break;
    default:
      jj_la1[28] = jj_gen;
      ;
    }
                                          fHandler.endComponent();
  }

  static final public void elementNoEnd() throws ParseException, XSCException {
  XSCNameValue n;
    label_8:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
      case NILLABLE:
      case QUALIFIED:
      case UNQUALIFIED:
      case FINAL:
      case FINAL_EXT:
      case FINAL_RESTR:
      case FINAL_LIST:
      case FINAL_UNION:
      case BLOCK:
      case BLOCK_SUBST:
      case BLOCK_RESTR:
      case BLOCK_EXT:
      case REQUIRED:
      case OPTIONAL:
      case PROHIBITED:
        ;
        break;
      default:
        jj_la1[29] = jj_gen;
        break label_8;
      }
      qualifier();
    }
    jj_consume_token(ELEMENT);
    n = name();
                                  fHandler.startComponent(XSCParserConstants.ELEMENT,n);
                                                          fHandler.extension(XSCParserConstants.ELEMENT,
                                                                                new XSCKeywordValue(XSCParserConstants.OPEN_PAR));
    label_9:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case RESTRICTS:
      case EXTENDS:
      case SUBSTITUTES:
        ;
        break;
      default:
        jj_la1[30] = jj_gen;
        break label_9;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SUBSTITUTES:
        substitution();
        break;
      case RESTRICTS:
      case EXTENDS:
        derivation();
        break;
      default:
        jj_la1[31] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case START_BLOCK:
      elementContent();
      break;
    default:
      jj_la1[32] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case EQUAL:
    case SET_DEF:
      fixedDefault();
      break;
    default:
      jj_la1[33] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case END_COMP:
      jj_consume_token(END_COMP);
      break;
    default:
      jj_la1[34] = jj_gen;
      ;
    }
  }

  static final public void elementShort() throws ParseException, XSCException {
  XSCNameValue n;
    n = name();
                                                  fHandler.startComponent(XSCParserConstants.ELEMENT,n);
                                                          fHandler.extension(XSCParserConstants.ELEMENT,
                                                                                new XSCKeywordValue(XSCParserConstants.OPEN_PAR));
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case START_BLOCK:
      jj_consume_token(START_BLOCK);
                                          fHandler.startBlock();
      n = name();
                                                  fHandler.startComponent(XSCParserConstants.RESTRICTS,n);
                                                          fHandler.endComponent();
      jj_consume_token(END_BLOCK);
                                                  fHandler.endBlock();
      break;
    default:
      jj_la1[35] = jj_gen;
      ;
    }
  }

  static final public void elementContent() throws ParseException, XSCException {
    jj_consume_token(START_BLOCK);
                                          fHandler.startBlock();
    label_10:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SIMPLE_TYPE:
      case UNION:
      case LIST:
      case ELEMENT:
      case ATTRIBUTE:
      case ATT_GROUP:
      case ANY_ATTR:
      case KEY:
      case KEYREF:
      case UNIQUE:
      case ABSTRACT:
      case NILLABLE:
      case QUALIFIED:
      case UNQUALIFIED:
      case FINAL:
      case FINAL_EXT:
      case FINAL_RESTR:
      case FINAL_LIST:
      case FINAL_UNION:
      case BLOCK:
      case BLOCK_SUBST:
      case BLOCK_RESTR:
      case BLOCK_EXT:
      case REQUIRED:
      case OPTIONAL:
      case PROHIBITED:
      case MIXED:
      case EMPTY:
      case LAX:
      case STRICT:
      case _SKIP:
      case OPEN_PAR:
      case GROUP_REF:
      case NAME_LIT:
      case NAME_ESCAPE:
        ;
        break;
      default:
        jj_la1[36] = jj_gen;
        break label_10;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SIMPLE_TYPE:
      case UNION:
      case LIST:
      case NAME_LIT:
      case NAME_ESCAPE:
        anonSimpleType();
        break;
      case ELEMENT:
      case ATTRIBUTE:
      case ATT_GROUP:
      case ANY_ATTR:
      case ABSTRACT:
      case NILLABLE:
      case QUALIFIED:
      case UNQUALIFIED:
      case FINAL:
      case FINAL_EXT:
      case FINAL_RESTR:
      case FINAL_LIST:
      case FINAL_UNION:
      case BLOCK:
      case BLOCK_SUBST:
      case BLOCK_RESTR:
      case BLOCK_EXT:
      case REQUIRED:
      case OPTIONAL:
      case PROHIBITED:
      case MIXED:
      case EMPTY:
      case LAX:
      case STRICT:
      case _SKIP:
      case OPEN_PAR:
      case GROUP_REF:
        anonComplexType();
        break;
      case KEY:
        key();
        break;
      case KEYREF:
        keyref();
        break;
      case UNIQUE:
        unique();
        break;
      default:
        jj_la1[37] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    jj_consume_token(END_BLOCK);
                                                  fHandler.endBlock();
  }

/* ---------------------- */
/* Structures : ATTRIBUTE */
/* ---------------------- */
  static final public void attribute() throws ParseException, XSCException {
  XSCNameValue n;
    label_11:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
      case NILLABLE:
      case QUALIFIED:
      case UNQUALIFIED:
      case FINAL:
      case FINAL_EXT:
      case FINAL_RESTR:
      case FINAL_LIST:
      case FINAL_UNION:
      case BLOCK:
      case BLOCK_SUBST:
      case BLOCK_RESTR:
      case BLOCK_EXT:
      case REQUIRED:
      case OPTIONAL:
      case PROHIBITED:
        ;
        break;
      default:
        jj_la1[38] = jj_gen;
        break label_11;
      }
      qualifier();
    }
    jj_consume_token(ATTRIBUTE);
    n = name();
                                  fHandler.startComponent(XSCParserConstants.ATTRIBUTE,n);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case START_BLOCK:
      attributeContent();
      break;
    default:
      jj_la1[39] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case EQUAL:
    case SET_DEF:
      fixedDefault();
      break;
    default:
      jj_la1[40] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case END_COMP:
      jj_consume_token(END_COMP);
      break;
    default:
      jj_la1[41] = jj_gen;
      ;
    }
                                                          fHandler.endComponent();
  }

  static final public void attributeContent() throws ParseException, XSCException {
    jj_consume_token(START_BLOCK);
                                          fHandler.startBlock();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SIMPLE_TYPE:
    case UNION:
    case LIST:
    case NAME_LIT:
    case NAME_ESCAPE:
      anonSimpleType();
      break;
    default:
      jj_la1[42] = jj_gen;
      ;
    }
    jj_consume_token(END_BLOCK);
                                                  fHandler.endBlock();
  }

/* ------------------------- */
/* Structures : COMPLEX TYPE */
/* ------------------------- */
  static final public void complexType() throws ParseException, XSCException {
  XSCNameValue n;
    label_12:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
      case NILLABLE:
      case QUALIFIED:
      case UNQUALIFIED:
      case FINAL:
      case FINAL_EXT:
      case FINAL_RESTR:
      case FINAL_LIST:
      case FINAL_UNION:
      case BLOCK:
      case BLOCK_SUBST:
      case BLOCK_RESTR:
      case BLOCK_EXT:
      case REQUIRED:
      case OPTIONAL:
      case PROHIBITED:
        ;
        break;
      default:
        jj_la1[43] = jj_gen;
        break label_12;
      }
      qualifier();
    }
    jj_consume_token(COMPLEX_TYPE);
    n = name();
                                  fHandler.startComponent(XSCParserConstants.COMPLEX_TYPE,n);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case RESTRICTS:
    case EXTENDS:
      derivation();
      break;
    default:
      jj_la1[44] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case START_BLOCK:
      complexTypeContent();
      break;
    default:
      jj_la1[45] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case END_COMP:
      jj_consume_token(END_COMP);
      break;
    default:
      jj_la1[46] = jj_gen;
      ;
    }
                                          fHandler.endComponent();
  }

  static final public void complexTypeContent() throws ParseException, XSCException {
    jj_consume_token(START_BLOCK);
                                          fHandler.startBlock();
    label_13:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SIMPLE_TYPE:
      case UNION:
      case LIST:
      case ELEMENT:
      case ATTRIBUTE:
      case ATT_GROUP:
      case ANY_ATTR:
      case ABSTRACT:
      case NILLABLE:
      case QUALIFIED:
      case UNQUALIFIED:
      case FINAL:
      case FINAL_EXT:
      case FINAL_RESTR:
      case FINAL_LIST:
      case FINAL_UNION:
      case BLOCK:
      case BLOCK_SUBST:
      case BLOCK_RESTR:
      case BLOCK_EXT:
      case REQUIRED:
      case OPTIONAL:
      case PROHIBITED:
      case MIXED:
      case EMPTY:
      case LAX:
      case STRICT:
      case _SKIP:
      case OPEN_PAR:
      case GROUP_REF:
      case NAME_LIT:
      case NAME_ESCAPE:
        ;
        break;
      default:
        jj_la1[47] = jj_gen;
        break label_13;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ELEMENT:
      case ATTRIBUTE:
      case ATT_GROUP:
      case ANY_ATTR:
      case ABSTRACT:
      case NILLABLE:
      case QUALIFIED:
      case UNQUALIFIED:
      case FINAL:
      case FINAL_EXT:
      case FINAL_RESTR:
      case FINAL_LIST:
      case FINAL_UNION:
      case BLOCK:
      case BLOCK_SUBST:
      case BLOCK_RESTR:
      case BLOCK_EXT:
      case REQUIRED:
      case OPTIONAL:
      case PROHIBITED:
      case MIXED:
      case EMPTY:
      case LAX:
      case STRICT:
      case _SKIP:
      case OPEN_PAR:
      case GROUP_REF:
        anonComplexType();
        break;
      case SIMPLE_TYPE:
      case UNION:
      case LIST:
      case NAME_LIT:
      case NAME_ESCAPE:
        anonSimpleType();
        break;
      default:
        jj_la1[48] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    jj_consume_token(END_BLOCK);
                                                  fHandler.endBlock();
  }

  static final public void anonComplexType() throws ParseException, XSCException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case MIXED:
    case EMPTY:
    case OPEN_PAR:
    case GROUP_REF:
      contentModel();
      break;
    default:
      jj_la1[49] = jj_gen;
      if (jj_2_7(2147483647)) {
        element();
      } else if (jj_2_8(2147483647)) {
        attribute();
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ANY_ATTR:
        case LAX:
        case STRICT:
        case _SKIP:
          attributeWC();
          break;
        case ATT_GROUP:
          attributeGroup();
          break;
        default:
          jj_la1[50] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    }
  }

  static final public void contentModel() throws ParseException, XSCException {
  Token m=null; XSCOccSpecValue v;
                                                          fHandler.startComponent(XSCParserConstants.MIXED,null);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case EMPTY:
      jj_consume_token(EMPTY);
                                                  fHandler.extension(0,new XSCKeywordValue(XSCParserConstants.EMPTY));
      break;
    case MIXED:
    case OPEN_PAR:
    case GROUP_REF:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case MIXED:
        m = jj_consume_token(MIXED);
        break;
      default:
        jj_la1[51] = jj_gen;
        ;
      }
                                          if (m!=null) fHandler.extension(0,new XSCKeywordValue(XSCParserConstants.MIXED));
                                                          fHandler.startBlock();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case OPEN_PAR:
        modelGroup();
        break;
      case GROUP_REF:
        groupRef();
        break;
      default:
        jj_la1[52] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case OPEN_SQ:
      case ONE_OR_ZERO:
      case ONE_OR_MORE:
      case ZERO_OR_MORE:
        v = occurrenceSpec();
                                       fHandler.extension(XSCParserConstants.ONE_OR_ZERO,v);
        break;
      default:
        jj_la1[53] = jj_gen;
        ;
      }
                                                          fHandler.endComponent();
                                                          fHandler.endBlock();
      break;
    default:
      jj_la1[54] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case END_COMP:
      jj_consume_token(END_COMP);
      break;
    default:
      jj_la1[55] = jj_gen;
      ;
    }
                                                          fHandler.endComponent();
  }

  static final public XSCOccSpecValue occurrenceSpec() throws ParseException, XSCException {
  XSCPosIntRange r;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ONE_OR_ZERO:
      jj_consume_token(ONE_OR_ZERO);
                                          {if (true) return new XSCOccSpecValue(0,1);}
      break;
    case ONE_OR_MORE:
      jj_consume_token(ONE_OR_MORE);
                                          {if (true) return new XSCOccSpecValue(1,-1);}
      break;
    case ZERO_OR_MORE:
      jj_consume_token(ZERO_OR_MORE);
                                          {if (true) return new XSCOccSpecValue(0,-1);}
      break;
    case OPEN_SQ:
      r = posIntRange();
                                          {if (true) return new XSCOccSpecValue(r);}
      break;
    default:
      jj_la1[56] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  static final public void modelGroup() throws ParseException, XSCException {
  int k = 0;
  int l = 0;
                                                          fHandler.startComponent(XSCParserConstants.OPEN_PAR,null);
    jj_consume_token(OPEN_PAR);
                                                  fHandler.startBlock();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OPEN_PAR:
    case START_BLOCK:
    case GROUP_REF:
    case NAME_LIT:
    case NAME_ESCAPE:
      particle();
      label_14:
      while (true) {
        if (jj_2_9(2)) {
          ;
        } else {
          break label_14;
        }
        k = compositor();
                                          if (l == 0 || k == l) l = k;
                                                                          else {if (true) throw new XSCException(XSCException.DifferentCompositors);}
        particle();
      }
      break;
    default:
      jj_la1[57] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case CHOICE:
    case SEQ:
    case ALL:
      k = compositor();
                                                          if (l == 0 || k == l) l = k;
                                                                          else {if (true) throw new XSCException(XSCException.DifferentCompositors);}
      break;
    default:
      jj_la1[58] = jj_gen;
      ;
    }
    jj_consume_token(CLOSE_PAR);
                                                  fHandler.endBlock();
                                                          fHandler.extension(XSCParserConstants.SEQ,new XSCKeywordValue(l));
  }

  static final public int compositor() throws ParseException, XSCException {
  Token c;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SEQ:
      c = jj_consume_token(SEQ);
      break;
    case CHOICE:
      c = jj_consume_token(CHOICE);
      break;
    case ALL:
      c = jj_consume_token(ALL);
      break;
    default:
      jj_la1[59] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
          {if (true) return c.kind;}
    throw new Error("Missing return statement in function");
  }

  static final public void particle() throws ParseException, XSCException {
  XSCOccSpecValue v;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OPEN_PAR:
      modelGroup();
      break;
    case NAME_LIT:
    case NAME_ESCAPE:
      elementShort();
      break;
    case GROUP_REF:
      groupRef();
      break;
    default:
      jj_la1[60] = jj_gen;
      if (jj_2_10(2)) {
        jj_consume_token(START_BLOCK);
        elementNoEnd();
        jj_consume_token(END_BLOCK);
      } else if (jj_2_11(2)) {
        jj_consume_token(START_BLOCK);
        elementWC();
        jj_consume_token(END_BLOCK);
      } else {
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OPEN_SQ:
    case ONE_OR_ZERO:
    case ONE_OR_MORE:
    case ZERO_OR_MORE:
      v = occurrenceSpec();
                                  fHandler.extension(XSCParserConstants.ONE_OR_ZERO,v);
      break;
    default:
      jj_la1[61] = jj_gen;
      ;
    }
                                                          fHandler.endComponent();
  }

/* ---------------------- */
/* Datatypes: SIMPLE TYPE */
/* ---------------------- */
  static final public void simpleType() throws ParseException, XSCException {
  XSCNameValue n;
    label_15:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ABSTRACT:
      case NILLABLE:
      case QUALIFIED:
      case UNQUALIFIED:
      case FINAL:
      case FINAL_EXT:
      case FINAL_RESTR:
      case FINAL_LIST:
      case FINAL_UNION:
      case BLOCK:
      case BLOCK_SUBST:
      case BLOCK_RESTR:
      case BLOCK_EXT:
      case REQUIRED:
      case OPTIONAL:
      case PROHIBITED:
        ;
        break;
      default:
        jj_la1[62] = jj_gen;
        break label_15;
      }
      qualifier();
    }
    jj_consume_token(SIMPLE_TYPE);
    n = name();
                                  fHandler.startComponent(XSCParserConstants.SIMPLE_TYPE,n);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case START_BLOCK:
      simpleTypeContent();
      break;
    default:
      jj_la1[63] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case END_COMP:
      jj_consume_token(END_COMP);
      break;
    default:
      jj_la1[64] = jj_gen;
      ;
    }
                                                          fHandler.endComponent();
  }

  static final public void simpleTypeContent() throws ParseException, XSCException {
    jj_consume_token(START_BLOCK);
                                          fHandler.startBlock();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SIMPLE_TYPE:
    case UNION:
    case LIST:
    case NAME_LIT:
    case NAME_ESCAPE:
      anonSimpleType();
      break;
    default:
      jj_la1[65] = jj_gen;
      ;
    }
    jj_consume_token(END_BLOCK);
                                                  fHandler.endBlock();
  }

  static final public void anonSimpleType() throws ParseException, XSCException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SIMPLE_TYPE:
    case NAME_LIT:
    case NAME_ESCAPE:
      restriction();
      break;
    case UNION:
      union();
      break;
    case LIST:
      list();
      break;
    default:
      jj_la1[66] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  static final public void restriction() throws ParseException, XSCException {
  XSCNameValue n;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case NAME_LIT:
    case NAME_ESCAPE:
      n = name();
                                                  fHandler.startComponent(XSCParserConstants.RESTRICTS,n);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case START_BLOCK:
        jj_consume_token(START_BLOCK);
                                          fHandler.extension(0,new XSCKeywordValue(XSCParserConstants.OPEN_PAR));
                                                          fHandler.startBlock();
        label_16:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case FIXED:
          case FIXED_MIN:
          case FIXED_MAX:
          case OPEN_PAR:
          case OPEN_SQ:
          case LENGTH:
          case WHITE_SPACE:
          case TOTAL_DIG:
          case FRACTION_DIG:
          case STRING_LIT:
          case PATTERN_LIT:
            ;
            break;
          default:
            jj_la1[67] = jj_gen;
            break label_16;
          }
          facet();
        }
        jj_consume_token(END_BLOCK);
                                                  fHandler.endBlock();
        break;
      default:
        jj_la1[68] = jj_gen;
        ;
      }
      break;
    case SIMPLE_TYPE:
      jj_consume_token(SIMPLE_TYPE);
                                          fHandler.startComponent(XSCParserConstants.RESTRICTS,null);
      jj_consume_token(START_BLOCK);
                                          fHandler.startBlock();
      anonSimpleType();
      jj_consume_token(END_BLOCK);
                                                  fHandler.endBlock();
      jj_consume_token(START_BLOCK);
                                          fHandler.extension(0,new XSCKeywordValue(XSCParserConstants.OPEN_PAR));
                                                          fHandler.startBlock();
      label_17:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case FIXED:
        case FIXED_MIN:
        case FIXED_MAX:
        case OPEN_PAR:
        case OPEN_SQ:
        case LENGTH:
        case WHITE_SPACE:
        case TOTAL_DIG:
        case FRACTION_DIG:
        case STRING_LIT:
        case PATTERN_LIT:
          ;
          break;
        default:
          jj_la1[69] = jj_gen;
          break label_17;
        }
        facet();
      }
      jj_consume_token(END_BLOCK);
                                                  fHandler.endBlock();
      break;
    default:
      jj_la1[70] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case END_COMP:
      jj_consume_token(END_COMP);
      break;
    default:
      jj_la1[71] = jj_gen;
      ;
    }
                                                          fHandler.endComponent();
  }

  static final public void union() throws ParseException, XSCException {
    jj_consume_token(UNION);
                                                  fHandler.startComponent(XSCParserConstants.UNION,null);
    jj_consume_token(START_BLOCK);
                                          fHandler.startBlock();
    label_18:
    while (true) {
      anonSimpleType();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SIMPLE_TYPE:
      case UNION:
      case LIST:
      case NAME_LIT:
      case NAME_ESCAPE:
        ;
        break;
      default:
        jj_la1[72] = jj_gen;
        break label_18;
      }
    }
    jj_consume_token(END_BLOCK);
                                                  fHandler.endBlock();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case END_COMP:
      jj_consume_token(END_COMP);
      break;
    default:
      jj_la1[73] = jj_gen;
      ;
    }
                                                          fHandler.endComponent();
  }

  static final public void list() throws ParseException, XSCException {
    jj_consume_token(LIST);
                                                  fHandler.startComponent(XSCParserConstants.LIST,null);
    jj_consume_token(START_BLOCK);
                                          fHandler.startBlock();
    anonSimpleType();
    jj_consume_token(END_BLOCK);
                                                  fHandler.endBlock();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case END_COMP:
      jj_consume_token(END_COMP);
      break;
    default:
      jj_la1[74] = jj_gen;
      ;
    }
                                                          fHandler.endComponent();
  }

/* ----------------- */
/* Datatypes: FACETS */
/* ----------------- */
  static final public void fixed() throws ParseException, XSCException {
  Token t;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FIXED:
      t = jj_consume_token(FIXED);
      break;
    case FIXED_MIN:
      t = jj_consume_token(FIXED_MIN);
      break;
    case FIXED_MAX:
      t = jj_consume_token(FIXED_MAX);
      break;
    default:
      jj_la1[75] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                                                          fHandler.qualifier(t.kind);
  }

  static final public void facet() throws ParseException, XSCException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FIXED:
    case FIXED_MIN:
    case FIXED_MAX:
      fixed();
      break;
    default:
      jj_la1[76] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LENGTH:
      lengthFacet();
      break;
    case OPEN_PAR:
    case OPEN_SQ:
      rangeFacet();
      break;
    case PATTERN_LIT:
      patternFacet();
      break;
    case STRING_LIT:
      enumFacet();
      break;
    case WHITE_SPACE:
      whiteSpaceFacet();
      break;
    case TOTAL_DIG:
      totalDigitsFacet();
      break;
    case FRACTION_DIG:
      fractionDigitsFacet();
      break;
    default:
      jj_la1[77] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case END_COMP:
      jj_consume_token(END_COMP);
      break;
    default:
      jj_la1[78] = jj_gen;
      ;
    }
  }

  static final public void lengthFacet() throws ParseException, XSCException {
  int i; XSCPosIntRange r;
                                                          fHandler.startComponent(XSCParserConstants.LENGTH,null);
    jj_consume_token(LENGTH);
    jj_consume_token(EQUAL);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case NUMBER_LIT:
      i = posInt();
                                          fHandler.extension(XSCParserConstants.LENGTH,new XSCIntValue(i));
      break;
    case OPEN_SQ:
      r = posIntRange();
                                          fHandler.extension(XSCParserConstants.LENGTH,r);
      break;
    default:
      jj_la1[79] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                                                          fHandler.endComponent();
  }

  static final public void rangeFacet() throws ParseException, XSCException {
  XSCRangeValue v;
                                                          fHandler.startComponent(XSCParserConstants.OPEN_SQ,null);
    v = numberRange();
                                          fHandler.extension(XSCParserConstants.OPEN_SQ,v);
                                                          fHandler.endComponent();
  }

  static final public void patternFacet() throws ParseException, XSCException {
  XSCPatternValue v;
                                                          fHandler.startComponent(XSCParserConstants.QUOTE_PAT,null);
    v = pattern();
                                                  fHandler.extension(XSCParserConstants.QUOTE_PAT,v);
                                                          fHandler.endComponent();
  }

  static final public void enumFacet() throws ParseException, XSCException {
  XSCStringValue s;
                                                          fHandler.startComponent(XSCParserConstants.SEQ,null);
    s = string();
                                                  fHandler.extension(XSCParserConstants.SEQ,s);
    label_19:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SEQ:
        ;
        break;
      default:
        jj_la1[80] = jj_gen;
        break label_19;
      }
      jj_consume_token(SEQ);
      s = string();
                                          fHandler.extension(XSCParserConstants.SEQ,s);
    }
                                                          fHandler.endComponent();
  }

  static final public void whiteSpaceFacet() throws ParseException, XSCException {
  Token t;
                                                          fHandler.startComponent(XSCParserConstants.WHITE_SPACE,null);
    jj_consume_token(WHITE_SPACE);
    jj_consume_token(EQUAL);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case PRESERVE:
      t = jj_consume_token(PRESERVE);
      break;
    case COLLAPSE:
      t = jj_consume_token(COLLAPSE);
      break;
    case REPLACE:
      t = jj_consume_token(REPLACE);
      break;
    default:
      jj_la1[81] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                                                          fHandler.extension(XSCParserConstants.WHITE_SPACE,new XSCKeywordValue(t.kind));
                                                          fHandler.endComponent();
  }

  static final public void totalDigitsFacet() throws ParseException, XSCException {
  int i;
                                                          fHandler.startComponent(XSCParserConstants.TOTAL_DIG,null);
    jj_consume_token(TOTAL_DIG);
    jj_consume_token(EQUAL);
    i = posInt();
                                                          fHandler.extension(XSCParserConstants.TOTAL_DIG, new XSCIntValue(i));
                                                          fHandler.endComponent();
  }

  static final public void fractionDigitsFacet() throws ParseException, XSCException {
  int i;
                                                          fHandler.startComponent(XSCParserConstants.FRACTION_DIG,null);
    jj_consume_token(FRACTION_DIG);
    jj_consume_token(EQUAL);
    i = posInt();
                                                          fHandler.extension(XSCParserConstants.FRACTION_DIG,new XSCIntValue(i));
                                                          fHandler.endComponent();
  }

/* ---------------------- */
/* Other features: Groups */
/* ---------------------- */
  static final public void group() throws ParseException, XSCException {
  XSCNameValue n;
    jj_consume_token(GROUP);
    n = name();
                                                  fHandler.startComponent(XSCParserConstants.GROUP,n);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case START_BLOCK:
      jj_consume_token(START_BLOCK);
                                                  fHandler.startBlock();
      label_20:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case MIXED:
        case EMPTY:
        case OPEN_PAR:
        case GROUP_REF:
          contentModel();
          break;
        case ELEMENT:
        case ABSTRACT:
        case NILLABLE:
        case QUALIFIED:
        case UNQUALIFIED:
        case FINAL:
        case FINAL_EXT:
        case FINAL_RESTR:
        case FINAL_LIST:
        case FINAL_UNION:
        case BLOCK:
        case BLOCK_SUBST:
        case BLOCK_RESTR:
        case BLOCK_EXT:
        case REQUIRED:
        case OPTIONAL:
        case PROHIBITED:
          element();
          break;
        default:
          jj_la1[82] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ELEMENT:
        case ABSTRACT:
        case NILLABLE:
        case QUALIFIED:
        case UNQUALIFIED:
        case FINAL:
        case FINAL_EXT:
        case FINAL_RESTR:
        case FINAL_LIST:
        case FINAL_UNION:
        case BLOCK:
        case BLOCK_SUBST:
        case BLOCK_RESTR:
        case BLOCK_EXT:
        case REQUIRED:
        case OPTIONAL:
        case PROHIBITED:
        case MIXED:
        case EMPTY:
        case OPEN_PAR:
        case GROUP_REF:
          ;
          break;
        default:
          jj_la1[83] = jj_gen;
          break label_20;
        }
      }
      jj_consume_token(END_BLOCK);
                                                                  fHandler.endBlock();
      break;
    default:
      jj_la1[84] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case END_COMP:
      jj_consume_token(END_COMP);
      break;
    default:
      jj_la1[85] = jj_gen;
      ;
    }
                                                  fHandler.endComponent();
  }

  static final public void groupRef() throws ParseException, XSCException {
  XSCNameValue n;
    jj_consume_token(GROUP_REF);
    n = name();
                                          fHandler.startComponent(XSCParserConstants.GROUP,n);
  }

  static final public void attributeGroup() throws ParseException, XSCException {
  XSCNameValue n;
    jj_consume_token(ATT_GROUP);
    n = name();
                                          fHandler.startComponent(XSCParserConstants.ATT_GROUP,n);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case START_BLOCK:
      jj_consume_token(START_BLOCK);
                                                  fHandler.startBlock();
      label_21:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ATTRIBUTE:
        case ABSTRACT:
        case NILLABLE:
        case QUALIFIED:
        case UNQUALIFIED:
        case FINAL:
        case FINAL_EXT:
        case FINAL_RESTR:
        case FINAL_LIST:
        case FINAL_UNION:
        case BLOCK:
        case BLOCK_SUBST:
        case BLOCK_RESTR:
        case BLOCK_EXT:
        case REQUIRED:
        case OPTIONAL:
        case PROHIBITED:
          attribute();
          break;
        case ANY_ATTR:
        case LAX:
        case STRICT:
        case _SKIP:
          attributeWC();
          break;
        case ATT_GROUP:
          attributeGroup();
          break;
        default:
          jj_la1[86] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ATTRIBUTE:
        case ATT_GROUP:
        case ANY_ATTR:
        case ABSTRACT:
        case NILLABLE:
        case QUALIFIED:
        case UNQUALIFIED:
        case FINAL:
        case FINAL_EXT:
        case FINAL_RESTR:
        case FINAL_LIST:
        case FINAL_UNION:
        case BLOCK:
        case BLOCK_SUBST:
        case BLOCK_RESTR:
        case BLOCK_EXT:
        case REQUIRED:
        case OPTIONAL:
        case PROHIBITED:
        case LAX:
        case STRICT:
        case _SKIP:
          ;
          break;
        default:
          jj_la1[87] = jj_gen;
          break label_21;
        }
      }
      jj_consume_token(END_BLOCK);
                                                  fHandler.endBlock();
      break;
    default:
      jj_la1[88] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case END_COMP:
      jj_consume_token(END_COMP);
      break;
    default:
      jj_la1[89] = jj_gen;
      ;
    }
                                                  fHandler.endComponent();
  }

/* ------------------------- */
/* Other features: Wildcards */
/* ------------------------- */
  static final public void process() throws ParseException, XSCException {
  Token t;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LAX:
      t = jj_consume_token(LAX);
      break;
    case STRICT:
      t = jj_consume_token(STRICT);
      break;
    case _SKIP:
      t = jj_consume_token(_SKIP);
      break;
    default:
      jj_la1[90] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                                                                  fHandler.qualifier(t.kind);
  }

  static final public void wildcardNSDecl() throws ParseException, XSCException {
  XSCURIValue v;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TARGET_NS_CONST:
      jj_consume_token(TARGET_NS_CONST);
                                                  fHandler.extension(XSCParserConstants.NAMESPACE,
                                                                                new XSCKeywordValue(XSCParserConstants.TARGET_NS_CONST));
      break;
    case OTHER_CONST:
      jj_consume_token(OTHER_CONST);
                                                  fHandler.extension(XSCParserConstants.NAMESPACE,
                                                                                new XSCKeywordValue(XSCParserConstants.OTHER_CONST));
      break;
    case LOCAL_CONST:
      jj_consume_token(LOCAL_CONST);
                                                  fHandler.extension(XSCParserConstants.NAMESPACE,
                                                                                new XSCKeywordValue(XSCParserConstants.LOCAL_CONST));
      break;
    case STRING_LIT:
      v = uri();
                                                          fHandler.extension(XSCParserConstants.NAMESPACE,v);
      break;
    default:
      jj_la1[91] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  static final public void elementWC() throws ParseException, XSCException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LAX:
    case STRICT:
    case _SKIP:
      process();
      break;
    default:
      jj_la1[92] = jj_gen;
      ;
    }
    jj_consume_token(ANY);
                                          fHandler.startComponent(XSCParserConstants.ANY,null);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case NAMESPACE:
      jj_consume_token(NAMESPACE);
      wildcardNSDecl();
      label_22:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SEQ:
          ;
          break;
        default:
          jj_la1[93] = jj_gen;
          break label_22;
        }
        jj_consume_token(SEQ);
        wildcardNSDecl();
      }
      break;
    default:
      jj_la1[94] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case END_COMP:
      jj_consume_token(END_COMP);
      break;
    default:
      jj_la1[95] = jj_gen;
      ;
    }
  }

  static final public void attributeWC() throws ParseException, XSCException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LAX:
    case STRICT:
    case _SKIP:
      process();
      break;
    default:
      jj_la1[96] = jj_gen;
      ;
    }
    jj_consume_token(ANY_ATTR);
                                          fHandler.startComponent(XSCParserConstants.ANY_ATTR,null);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case NAMESPACE:
      jj_consume_token(NAMESPACE);
      wildcardNSDecl();
      label_23:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SEQ:
          ;
          break;
        default:
          jj_la1[97] = jj_gen;
          break label_23;
        }
        jj_consume_token(SEQ);
        wildcardNSDecl();
      }
      break;
    default:
      jj_la1[98] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case END_COMP:
      jj_consume_token(END_COMP);
      break;
    default:
      jj_la1[99] = jj_gen;
      ;
    }
                                                  fHandler.endComponent();
  }

/* ------------------------------------ */
/* Other features: Identity constraints */
/* ------------------------------------ */
  static final public void idConstrField() throws ParseException, XSCException {
  XSCXPathValue v;
    jj_consume_token(FIELD);
    v = xpath();
                                                  fHandler.extension(XSCParserConstants.FIELD,v);
    label_24:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SEQ:
        ;
        break;
      default:
        jj_la1[100] = jj_gen;
        break label_24;
      }
      jj_consume_token(SEQ);
      v = xpath();
                                                  fHandler.extension(XSCParserConstants.FIELD,v);
    }
    jj_consume_token(IN);
    v = xpath();
                                                  fHandler.extension(XSCParserConstants.IN,v);
  }

  static final public void key() throws ParseException, XSCException {
  XSCNameValue n;
    jj_consume_token(KEY);
    n = name();
                                                  fHandler.startComponent(XSCParserConstants.KEY,n);
    idConstrField();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case END_COMP:
      jj_consume_token(END_COMP);
      break;
    default:
      jj_la1[101] = jj_gen;
      ;
    }
                                                  fHandler.endComponent();
  }

  static final public void keyref() throws ParseException, XSCException {
  XSCNameValue n;
    jj_consume_token(KEYREF);
    n = name();
                                                  fHandler.startComponent(XSCParserConstants.KEYREF,n);
    jj_consume_token(REFERS);
    n = name();
                                                  fHandler.extension(XSCParserConstants.REFERS,n);
    idConstrField();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case END_COMP:
      jj_consume_token(END_COMP);
      break;
    default:
      jj_la1[102] = jj_gen;
      ;
    }
                                                  fHandler.endComponent();
  }

  static final public void unique() throws ParseException, XSCException {
  XSCNameValue n;
    jj_consume_token(UNIQUE);
    n = name();
                                                  fHandler.startComponent(XSCParserConstants.UNIQUE,n);
    idConstrField();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case END_COMP:
      jj_consume_token(END_COMP);
      break;
    default:
      jj_la1[103] = jj_gen;
      ;
    }
                                                  fHandler.endComponent();
  }

/* ------------------------- */
/* Other features: Notations */
/* ------------------------- */
  static final public void notation() throws ParseException, XSCException {
  XSCNameValue n; XSCStringValue s; XSCURIValue u;
    jj_consume_token(NOTATION);
    n = name();
                                          fHandler.startComponent(XSCParserConstants.NOTATION,n);
    jj_consume_token(PUBLIC);
    s = string();
                                          fHandler.extension(XSCParserConstants.PUBLIC,s);
    jj_consume_token(SYSTEM);
    u = uri();
                                                  fHandler.extension(XSCParserConstants.SYSTEM,u);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case END_COMP:
      jj_consume_token(END_COMP);
      break;
    default:
      jj_la1[104] = jj_gen;
      ;
    }
                                                  fHandler.endComponent();
  }

/* -------- */
/* LITERALS */
/* -------- */
  static final public XSCNameValue name() throws ParseException, XSCException {
  Token n;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case NAME_LIT:
      n = jj_consume_token(NAME_LIT);
      break;
    case NAME_ESCAPE:
      jj_consume_token(NAME_ESCAPE);
      n = jj_consume_token(NAME_LIT);
      break;
    default:
      jj_la1[105] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                                                          {if (true) return new XSCNameValue(n.image);}
    throw new Error("Missing return statement in function");
  }

  static final public XSCStringValue string() throws ParseException, XSCException {
  Token t;
    t = jj_consume_token(STRING_LIT);
                                                          {if (true) return new XSCStringValue(t.image,true);}
    throw new Error("Missing return statement in function");
  }

  static final public XSCXPathValue xpath() throws ParseException, XSCException {
  Token t;
    t = jj_consume_token(STRING_LIT);
                                                          {if (true) return new XSCXPathValue(t.image,true);}
    throw new Error("Missing return statement in function");
  }

  static final public XSCPatternValue pattern() throws ParseException, XSCException {
  Token t;
    t = jj_consume_token(PATTERN_LIT);
                                                          {if (true) return new XSCPatternValue(t.image,true);}
    throw new Error("Missing return statement in function");
  }

  static final public XSCURIValue uri() throws ParseException, XSCException {
  Token t;
    t = jj_consume_token(STRING_LIT);
                                                          {if (true) return new XSCURIValue(t.image,true);}
    throw new Error("Missing return statement in function");
  }

  static final public int posInt() throws ParseException, XSCException {
  Token t;
    t = jj_consume_token(NUMBER_LIT);
                                                          int result = 0;
                                                          try {result = Integer.parseInt(t.image);}
                                                          catch (Exception e) {{if (true) throw new XSCException(XSCException.IllIntRangeValue);}}
                                                          {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  static final public XSCPosIntRange posIntRange() throws ParseException, XSCException {
  int min = -1; int max = -1;
    jj_consume_token(OPEN_SQ);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case NUMBER_LIT:
      min = posInt();
                              max=min;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SEQ:
        jj_consume_token(SEQ);
                                                 max=-1;
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case NUMBER_LIT:
          max = posInt();
          break;
        default:
          jj_la1[106] = jj_gen;
          ;
        }
        break;
      default:
        jj_la1[107] = jj_gen;
        ;
      }
      break;
    case SEQ:
      jj_consume_token(SEQ);
      max = posInt();
      break;
    default:
      jj_la1[108] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(CLOSE_SQ);
                                                          {if (true) return new XSCPosIntRange(min,max);}
    throw new Error("Missing return statement in function");
  }

  static final public String number() throws ParseException, XSCException {
  Token t;
    t = jj_consume_token(NUMBER_LIT);
                                                          {if (true) return t.image;}
    throw new Error("Missing return statement in function");
  }

  static final public XSCRangeValue numberRange() throws ParseException, XSCException {
  String min=null; String max=null; Token t;
  boolean minIncl; boolean maxIncl;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OPEN_SQ:
      t = jj_consume_token(OPEN_SQ);
      break;
    case OPEN_PAR:
      t = jj_consume_token(OPEN_PAR);
      break;
    default:
      jj_la1[109] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                                                  minIncl = (t.kind == XSCParserConstants.OPEN_SQ);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case NUMBER_LIT:
      min = number();
      jj_consume_token(SEQ);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case NUMBER_LIT:
        max = number();
        break;
      default:
        jj_la1[110] = jj_gen;
        ;
      }
      break;
    case SEQ:
      jj_consume_token(SEQ);
      max = number();
      break;
    default:
      jj_la1[111] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case CLOSE_SQ:
      t = jj_consume_token(CLOSE_SQ);
      break;
    case CLOSE_PAR:
      t = jj_consume_token(CLOSE_PAR);
      break;
    default:
      jj_la1[112] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                                                  maxIncl = (t.kind == XSCParserConstants.CLOSE_SQ);
                                                          {if (true) return new XSCRangeValue(min,minIncl,max,maxIncl);}
    throw new Error("Missing return statement in function");
  }

  static final private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_1();
    jj_save(0, xla);
    return retval;
  }

  static final private boolean jj_2_2(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_2();
    jj_save(1, xla);
    return retval;
  }

  static final private boolean jj_2_3(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_3();
    jj_save(2, xla);
    return retval;
  }

  static final private boolean jj_2_4(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_4();
    jj_save(3, xla);
    return retval;
  }

  static final private boolean jj_2_5(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_5();
    jj_save(4, xla);
    return retval;
  }

  static final private boolean jj_2_6(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_6();
    jj_save(5, xla);
    return retval;
  }

  static final private boolean jj_2_7(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_7();
    jj_save(6, xla);
    return retval;
  }

  static final private boolean jj_2_8(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_8();
    jj_save(7, xla);
    return retval;
  }

  static final private boolean jj_2_9(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_9();
    jj_save(8, xla);
    return retval;
  }

  static final private boolean jj_2_10(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_10();
    jj_save(9, xla);
    return retval;
  }

  static final private boolean jj_2_11(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_11();
    jj_save(10, xla);
    return retval;
  }

  static final private boolean jj_3R_60() {
    if (jj_scan_token(REQUIRED)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_58() {
    if (jj_scan_token(NILLABLE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_56() {
    if (jj_scan_token(UNQUALIFIED)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_9() {
    if (jj_3R_33()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_34()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_52() {
    if (jj_scan_token(BLOCK_SUBST)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_69() {
    if (jj_scan_token(_SKIP)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_47() {
    if (jj_scan_token(FINAL_EXT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_28() {
    if (jj_3R_37()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_45() {
    if (jj_3R_65()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_27() {
    if (jj_3R_37()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_4() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_28()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(ATTRIBUTE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_36() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_45()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(ANY)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_26() {
    if (jj_3R_37()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_3() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_27()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(ELEMENT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_71() {
    if (jj_scan_token(NAME_ESCAPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_59() {
    if (jj_scan_token(OPTIONAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_25() {
    if (jj_3R_37()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_2() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_26()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(COMPLEX_TYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_57() {
    if (jj_scan_token(ABSTRACT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_55() {
    if (jj_scan_token(QUALIFIED)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_1() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_25()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(SIMPLE_TYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_51() {
    if (jj_scan_token(BLOCK)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_46() {
    if (jj_scan_token(FINAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_68() {
    if (jj_scan_token(STRICT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_30() {
    if (jj_3R_37()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_6() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_30()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(COMPLEX_TYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_37() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_46()) {
    jj_scanpos = xsp;
    if (jj_3R_47()) {
    jj_scanpos = xsp;
    if (jj_3R_48()) {
    jj_scanpos = xsp;
    if (jj_3R_49()) {
    jj_scanpos = xsp;
    if (jj_3R_50()) {
    jj_scanpos = xsp;
    if (jj_3R_51()) {
    jj_scanpos = xsp;
    if (jj_3R_52()) {
    jj_scanpos = xsp;
    if (jj_3R_53()) {
    jj_scanpos = xsp;
    if (jj_3R_54()) {
    jj_scanpos = xsp;
    if (jj_3R_55()) {
    jj_scanpos = xsp;
    if (jj_3R_56()) {
    jj_scanpos = xsp;
    if (jj_3R_57()) {
    jj_scanpos = xsp;
    if (jj_3R_58()) {
    jj_scanpos = xsp;
    if (jj_3R_59()) {
    jj_scanpos = xsp;
    if (jj_3R_60()) {
    jj_scanpos = xsp;
    if (jj_3R_61()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_29() {
    if (jj_3R_37()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_32() {
    if (jj_3R_37()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_70() {
    if (jj_scan_token(NAME_LIT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_5() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_29()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(SIMPLE_TYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_67() {
    if (jj_scan_token(LAX)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_8() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_32()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(ATTRIBUTE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_31() {
    if (jj_3R_37()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_66() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_70()) {
    jj_scanpos = xsp;
    if (jj_3R_71()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_65() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_67()) {
    jj_scanpos = xsp;
    if (jj_3R_68()) {
    jj_scanpos = xsp;
    if (jj_3R_69()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_7() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_31()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(ELEMENT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_63() {
    if (jj_3R_66()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_50() {
    if (jj_scan_token(FINAL_UNION)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_64() {
    if (jj_scan_token(GROUP_REF)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_62() {
    if (jj_scan_token(OPEN_PAR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_44() {
    if (jj_3R_37()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_40() {
    if (jj_scan_token(ALL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_35() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_44()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(ELEMENT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_54() {
    if (jj_scan_token(BLOCK_EXT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_11() {
    if (jj_scan_token(START_BLOCK)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_36()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_49() {
    if (jj_scan_token(FINAL_LIST)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_10() {
    if (jj_scan_token(START_BLOCK)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_35()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_43() {
    if (jj_3R_64()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_42() {
    if (jj_3R_63()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_41() {
    if (jj_3R_62()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_39() {
    if (jj_scan_token(CHOICE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_34() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_41()) {
    jj_scanpos = xsp;
    if (jj_3R_42()) {
    jj_scanpos = xsp;
    if (jj_3R_43()) {
    jj_scanpos = xsp;
    if (jj_3_10()) {
    jj_scanpos = xsp;
    if (jj_3_11()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_61() {
    if (jj_scan_token(PROHIBITED)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_53() {
    if (jj_scan_token(BLOCK_RESTR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_38() {
    if (jj_scan_token(SEQ)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_48() {
    if (jj_scan_token(FINAL_RESTR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_33() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_38()) {
    jj_scanpos = xsp;
    if (jj_3R_39()) {
    jj_scanpos = xsp;
    if (jj_3R_40()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static private boolean jj_initialized_once = false;
  static public XSCParserTokenManager token_source;
  static JavaCharStream jj_input_stream;
  static public Token token, jj_nt;
  static private int jj_ntk;
  static private Token jj_scanpos, jj_lastpos;
  static private int jj_la;
  static public boolean lookingAhead = false;
  static private boolean jj_semLA;
  static private int jj_gen;
  static final private int[] jj_la1 = new int[113];
  static final private int[] jj_la1_0 = {0x3f0,0x1c00,0x9e6000,0x3f0,0x1c00,0x980000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x186000,0x180000,0x0,0x0,0x0,0xc0000000,0x0,0x0,0xc0000000,0xc0000000,0x0,0x0,0x0,0x0,0xc0000000,0xc0000000,0x0,0x0,0x0,0x0,0x737c000,0x737c000,0x0,0x0,0x0,0x0,0x1c000,0x0,0xc0000000,0x0,0x0,0x37c000,0x37c000,0x0,0x300000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1c000,0x1c000,0x0,0x0,0x0,0x4000,0x0,0x1c000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x20000,0x20000,0x0,0x0,0x340000,0x340000,0x0,0x0,0x0,0x0,0x0,0x0,0x20,0x0,0x0,0x0,0x20,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,};
  static final private int[] jj_la1_1 = {0x0,0x0,0x3fffc0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x3fffc0,0x0,0x0,0x0,0x3fffc0,0x0,0x0,0x3fffc0,0x1,0x1,0x0,0x0,0x0,0x3fffc0,0x1,0x1,0x0,0x0,0x0,0x0,0x38ffffc0,0x38ffffc0,0x3fffc0,0x0,0x0,0x0,0x0,0x3fffc0,0x0,0x0,0x0,0x38ffffc0,0x38ffffc0,0xc00000,0x38000000,0x400000,0x0,0x0,0xc00000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x3fffc0,0x0,0x0,0x0,0x0,0x7000000,0x0,0x7000000,0x0,0x0,0x0,0x0,0x0,0x7000000,0x7000000,0x0,0x0,0x0,0x0,0x0,0xffffc0,0xffffc0,0x0,0x0,0x383fffc0,0x383fffc0,0x0,0x0,0x38000000,0x38,0x38000000,0x0,0x0,0x0,0x38000000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,};
  static final private int[] jj_la1_2 = {0x0,0x0,0x0,0x0,0x0,0x0,0x200,0x0,0x200,0x20,0x200,0x200,0x200,0x200,0x200,0x200,0x0,0x0,0x80,0x200,0x0,0x0,0x6000,0x0,0x0,0x0,0x80,0x6000,0x200,0x0,0x0,0x0,0x80,0x6000,0x200,0x80,0x8001,0x8001,0x0,0x80,0x6000,0x200,0x0,0x0,0x0,0x80,0x200,0x8001,0x8001,0x8001,0x0,0x0,0x8001,0x1c04,0x8001,0x200,0x1c04,0x8081,0x70,0x70,0x8001,0x1c04,0x0,0x80,0x200,0x0,0x0,0x630005,0x80,0x630005,0x0,0x200,0x0,0x200,0x200,0x0,0x0,0x630005,0x200,0x10000004,0x20,0x1c0000,0x8001,0x8001,0x80,0x200,0x0,0x0,0x80,0x200,0x0,0x0,0x0,0x20,0x0,0x200,0x0,0x20,0x0,0x200,0x20,0x200,0x200,0x200,0x200,0x0,0x10000000,0x20,0x10000020,0x5,0x10000000,0x10000020,0xa,};
  static final private int[] jj_la1_3 = {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x21,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x21,0x21,0x0,0x0,0x0,0x0,0x21,0x0,0x0,0x0,0x0,0x21,0x21,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x21,0x0,0x0,0x21,0x0,0x0,0x0,0x0,0x21,0x21,0xc0,0x0,0xc0,0x21,0x0,0x21,0x0,0x0,0x0,0x0,0xc0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x40,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x21,0x0,0x0,0x0,0x0,0x0,0x0,0x0,};
  static final private JJCalls[] jj_2_rtns = new JJCalls[11];
  static private boolean jj_rescan = false;
  static private int jj_gc = 0;

  public XSCParser(java.io.InputStream stream) {
    if (jj_initialized_once) {
      System.out.println("ERROR: Second call to constructor of static parser.  You must");
      System.out.println("       either use ReInit() or set the JavaCC option STATIC to false");
      System.out.println("       during parser generation.");
      throw new Error();
    }
    jj_initialized_once = true;
    jj_input_stream = new JavaCharStream(stream, 1, 1);
    token_source = new XSCParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 113; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  static public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 113; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public XSCParser(java.io.Reader stream) {
    if (jj_initialized_once) {
      System.out.println("ERROR: Second call to constructor of static parser.  You must");
      System.out.println("       either use ReInit() or set the JavaCC option STATIC to false");
      System.out.println("       during parser generation.");
      throw new Error();
    }
    jj_initialized_once = true;
    jj_input_stream = new JavaCharStream(stream, 1, 1);
    token_source = new XSCParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 113; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  static public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 113; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public XSCParser(XSCParserTokenManager tm) {
    if (jj_initialized_once) {
      System.out.println("ERROR: Second call to constructor of static parser.  You must");
      System.out.println("       either use ReInit() or set the JavaCC option STATIC to false");
      System.out.println("       during parser generation.");
      throw new Error();
    }
    jj_initialized_once = true;
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 113; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(XSCParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 113; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  static final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  static final private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    return (jj_scanpos.kind != kind);
  }

  static final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  static final public Token getToken(int index) {
    Token t = lookingAhead ? jj_scanpos : token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  static final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  static private java.util.Vector jj_expentries = new java.util.Vector();
  static private int[] jj_expentry;
  static private int jj_kind = -1;
  static private int[] jj_lasttokens = new int[100];
  static private int jj_endpos;

  static private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      boolean exists = false;
      for (java.util.Enumeration enum = jj_expentries.elements(); enum.hasMoreElements();) {
        int[] oldentry = (int[])(enum.nextElement());
        if (oldentry.length == jj_expentry.length) {
          exists = true;
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              exists = false;
              break;
            }
          }
          if (exists) break;
        }
      }
      if (!exists) jj_expentries.addElement(jj_expentry);
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  static final public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[106];
    for (int i = 0; i < 106; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 113; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
          if ((jj_la1_2[i] & (1<<j)) != 0) {
            la1tokens[64+j] = true;
          }
          if ((jj_la1_3[i] & (1<<j)) != 0) {
            la1tokens[96+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 106; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  static final public void enable_tracing() {
  }

  static final public void disable_tracing() {
  }

  static final private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 11; i++) {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
            case 1: jj_3_2(); break;
            case 2: jj_3_3(); break;
            case 3: jj_3_4(); break;
            case 4: jj_3_5(); break;
            case 5: jj_3_6(); break;
            case 6: jj_3_7(); break;
            case 7: jj_3_8(); break;
            case 8: jj_3_9(); break;
            case 9: jj_3_10(); break;
            case 10: jj_3_11(); break;
          }
        }
        p = p.next;
      } while (p != null);
    }
    jj_rescan = false;
  }

  static final private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

}
