package noown.domain.xsc.comp;

import noown.domain.xsc.XSCDOMBuilder;
import noown.domain.xsc.XSCException;
import noown.domain.xsc.XSCHandler;
import noown.domain.xsc.XSCParserConstants;
import noown.domain.xsc.util.XSCNodeListImpl;
import noown.domain.xsc.val.XSCValue;

import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

/**
 * Attribute wildcard component
 * 
 * @author Kilian Stillhard
 */
public class XSCAttributeWildcard extends XSCWildcard
{
	public XSCAttributeWildcard() throws XSCException
	{
		super();
	}

	public XSCAttributeWildcard(NodeList nodes) throws XSCException
	{
		super(nodes);
	}

	public int getType()
	{
		return XSCValue.ATTRIBUTE_WC;
	}

	protected void freeze_() throws XSCException
	{
		Element wc = XSCDOMBuilder.getBuilder().createSchemaElement("anyAttribute");
		XSCCommon.addAnnotation(wc,annot);
		addNodes(wc,getWildcardAttrs());
		((XSCNodeListImpl)fNodes).add(wc);
	}
}
