package noown.domain.xsc.comp;

import java.util.Vector;

import noown.domain.xsc.XSCDOMBuilder;
import noown.domain.xsc.XSCException;
import noown.domain.xsc.XSCHandler;
import noown.domain.xsc.XSCParserConstants;
import noown.domain.xsc.util.XSCNodeListImpl;
import noown.domain.xsc.val.XSCAnnotationValue;
import noown.domain.xsc.val.XSCKeywordValue;
import noown.domain.xsc.val.XSCValue;

import org.w3c.dom.Attr;
import org.w3c.dom.NodeList;

public class XSCDefault extends XSCComponent
{

	protected Vector fKeywords;
	private XSCAnnotationValue annot;

	public XSCDefault() throws XSCException
	{
		super();
		fKeywords = new Vector();
	}

	public XSCDefault(NodeList nodes) throws XSCException
	{
		super(nodes);
	}

	public int getType()
	{
		return XSCValue.DEFAULT;
	}

	protected void property_(XSCValue value,int subtype) throws XSCException
	{
		switch (value.getType())
		{
			case XSCValue.KEYWORD_VALUE:
			{ 
				switch (((XSCKeywordValue)value).getKey())
				{
					case XSCParserConstants.FINAL:
					case XSCParserConstants.FINAL_EXT:
					case XSCParserConstants.FINAL_RESTR:
					case XSCParserConstants.BLOCK:
					case XSCParserConstants.BLOCK_EXT:
					case XSCParserConstants.BLOCK_RESTR:
					case XSCParserConstants.BLOCK_SUBST:
					{ fKeywords.add((XSCKeywordValue)value); break; }
					default:
						throw new XSCException(XSCException.IllQDefault,value);
				}
				break;
			}
			case XSCValue.ANNOT_VALUE:
			{ annot = XSCCommon.mergeAnnotations(annot,(XSCAnnotationValue)value); break; }
			default:
				throw new XSCException(XSCException.IllegalProperty,value);
		}
	}

	protected void freeze_() throws XSCException
	{
		if (annot != null) XSCDOMBuilder.getBuilder().getSchema().property(annot,0);
		
		String blockValue = XSCCommon.getBlockAttr(fKeywords);
		
		if (blockValue != null)
		{
			Attr bl = XSCDOMBuilder.getBuilder().createSchemaAttr("blockDefault");
			bl.setValue(blockValue);
			((XSCNodeListImpl)fNodes).add(bl);
		}
		
		String finalValue = XSCCommon.getFinalAttr(fKeywords);
		if (finalValue != null)
		{
			Attr fi = XSCDOMBuilder.getBuilder().createSchemaAttr("finalDefault");
			fi.setValue(finalValue);
			((XSCNodeListImpl)fNodes).add(fi);
		}
	}

}
