package noown.domain.xsc.comp;

import noown.domain.xsc.XSCDOMBuilder;
import noown.domain.xsc.XSCException;
import noown.domain.xsc.XSCHandler;
import noown.domain.xsc.XSCParserConstants;
import noown.domain.xsc.util.XSCNodeListImpl;
import noown.domain.xsc.val.XSCAnnotationValue;
import noown.domain.xsc.val.XSCURIValue;
import noown.domain.xsc.val.XSCValue;

import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

/**
 * Import statement
 * 
 * @author Kilian Stillhard
 */
public class XSCInclude extends XSCComponent
{
	private XSCURIValue fURI;
	private XSCAnnotationValue annot;

	public XSCInclude() throws XSCException
	{
		super();
	}

	public XSCInclude(NodeList nodes) throws XSCException
	{
		super(nodes);
	}

	public int getType()
	{
		return XSCValue.INCLUDE;
	}

	protected void property_(XSCValue value, int subtype) throws XSCException
	{
		switch (value.getType())
		{
			case XSCValue.URI_VALUE:
			{
				fURI = (XSCURIValue)value;
				break;
			}
			case XSCValue.ANNOT_VALUE:
			{ annot = XSCCommon.mergeAnnotations(annot,(XSCAnnotationValue)value);break;}
			default:
				throw new XSCException(XSCException.IllegalProperty,value);
		}		
	}


	protected void freeze_() throws XSCException
	{
		Element inc = XSCDOMBuilder.getBuilder().createSchemaElement("include");
		XSCCommon.addAnnotation(inc,annot);
		inc.setAttribute("schemaLocation",fURI.getXMLString());
		
		((XSCNodeListImpl)fNodes).add(inc);
	}
}
