package noown.domain.xsc.comp;

import noown.domain.xsc.XSCDOMBuilder;
import noown.domain.xsc.XSCException;
import noown.domain.xsc.XSCHandler;
import noown.domain.xsc.util.XSCNodeListImpl;
import noown.domain.xsc.val.XSCValue;

import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

/**
 * Key Identity constraint component
 * 
 * @author Kilian Stillhard
 */
public class XSCKey extends XSCIDConstraint
{

	public XSCKey() throws XSCException
	{
		super();
	}

	public XSCKey(NodeList nodes) throws XSCException
	{
		super(nodes);
	}

	public int getType()
	{
		return XSCValue.KEY;
	}

	protected void freeze_() throws XSCException
	{
		Element ky = XSCDOMBuilder.getBuilder().createSchemaElement("key");
		XSCCommon.addAnnotation(ky,annot);
		addNodes(ky,getIDConstr());
		((XSCNodeListImpl)fNodes).add(ky);
	}
}
