package noown.domain.xsc.comp;

import noown.domain.xsc.XSCDOMBuilder;
import noown.domain.xsc.XSCException;
import noown.domain.xsc.XSCHandler;
import noown.domain.xsc.XSCParserConstants;
import noown.domain.xsc.util.XSCNodeListImpl;
import noown.domain.xsc.val.XSCNameValue;
import noown.domain.xsc.val.XSCValue;
import noown.domain.xsc.val.XSCXPathValue;

import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

/**
 * Keyref identity constraint component
 * 
 * @author Kilian Stillhard
 */
public class XSCKeyref extends XSCIDConstraint
{
	private XSCNameValue refer;
	
	public XSCKeyref() throws XSCException
	{
		super();
	}
	
	public XSCKeyref(NodeList nodes) throws XSCException
	{
		super(nodes);
	}

	public int getType()
	{
		return XSCValue.KEYREF;
	}
	
	protected void property_(XSCValue value,int subtype) throws XSCException
	{
		super.property_(value,subtype);
		if (value.getType() == XSCValue.NAME_VALUE && 
			subtype == XSCParserConstants.REFERS)
			refer = (XSCNameValue)value;
	}

	protected void freeze_() throws XSCException
	{
		Element ky = XSCDOMBuilder.getBuilder().createSchemaElement("key");
		XSCCommon.addAnnotation(ky,annot);
		ky.setAttribute("refer",refer.getXMLString());
		addNodes(ky,getIDConstr());
		((XSCNodeListImpl)fNodes).add(ky);
	}
}
