package noown.domain.xsc.comp;

import noown.domain.xsc.XSCDOMBuilder;
import noown.domain.xsc.XSCException;
import noown.domain.xsc.val.XSCURIValue;
import noown.domain.xsc.val.XSCValue;

/**
 *Target namespace declaration
 * 
 * @author Kilian Stillhard
 */
public class XSCTargetNamespace extends XSCNamespace
{
	public XSCTargetNamespace() throws XSCException
	{
		super();
	}
	
	
	protected void property_(XSCValue value, int subtype) throws XSCException
	{
		switch (value.getType())
		{
			case XSCValue.URI_VALUE:
			{
				if (fTargetNS == null)
				{
					fTargetNS = ((XSCURIValue)value).getXMLString();
				} else {
					throw new XSCException(XSCException.DupTNS);
				}
				break;
			}
			case XSCValue.ANNOT_VALUE:
			{ XSCDOMBuilder.getBuilder().getSchema().property(value,0); break;}
			default:
				throw new XSCException(XSCException.IllegalProperty,value);
		}
	}
	
	public int getType()
	{
		return XSCValue.TARGET_NAMESPACE;
	}
	
	public static void setTargetNamespace(String uri)
	{
		fTargetNS = uri;
	}
}
