package noown.domain.xsc.comp;

import noown.domain.xsc.XSCDOMBuilder;
import noown.domain.xsc.XSCException;
import noown.domain.xsc.XSCHandler;
import noown.domain.xsc.util.XSCNodeListImpl;
import noown.domain.xsc.val.XSCValue;

import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

/**
 * Unique identity constraint
 * 
 * @author Kilian Stillhard
 */
public class XSCUnique extends XSCIDConstraint
{
	public XSCUnique() throws XSCException
	{
		super();
	}

	public XSCUnique(NodeList nodes) throws XSCException
	{
		super(nodes);
	}

	public int getType()
	{
		return XSCValue.UNIQUE;
	}

	protected void freeze_() throws XSCException
	{
		Element un = XSCDOMBuilder.getBuilder().createSchemaElement("unique");
		XSCCommon.addAnnotation(un,annot);
		addNodes(un,getIDConstr());
		((XSCNodeListImpl)fNodes).add(un);
	}
}
