package noown.domain.xsc.comp;

import noown.domain.xsc.XSCDOMBuilder;
import noown.domain.xsc.XSCException;
import noown.domain.xsc.XSCHandler;
import noown.domain.xsc.XSCParserConstants;
import noown.domain.xsc.util.XSCNodeListImpl;
import noown.domain.xsc.val.XSCStringValue;
import noown.domain.xsc.val.XSCValue;

import org.w3c.dom.Attr;
import org.w3c.dom.NodeList;

public class XSCVersion extends XSCComponent
{
	private XSCStringValue version;
	
	public XSCVersion() throws XSCException
	{
		super();
	}

	public XSCVersion(NodeList nodes) throws XSCException
	{
		super(nodes);
	}

	public int getType()
	{
		return XSCValue.VERSION;
	}
	
	protected void property_(XSCValue value, int subtype) throws XSCException
	{
		switch (value.getType())
		{
			case XSCValue.STRING_VALUE:
			{ version = (XSCStringValue)value; break; }
			case XSCValue.ANNOT_VALUE:
			{ XSCDOMBuilder.getBuilder().getSchema().property(value,0); break;}
			default:
				throw new XSCException(XSCException.IllegalProperty,value);
		}	
	}

	protected void freeze_() throws XSCException
	{
		Attr ver = XSCDOMBuilder.getBuilder().createSchemaAttr("version");
		ver.setValue(version.getXMLString());
		
		((XSCNodeListImpl)fNodes).add(ver);
	}
}
