package noown.domain.xsc.val;

import noown.domain.xsc.XSCException;
import org.w3c.dom.NodeList;

/**
 * Class that holds an Integer value
 *  
 * @author Kilian Stillhard
 */
public class XSCIntValue extends XSCSimpleValue
{
	protected int fValue;
	
	public XSCIntValue(int value)
	{
		fValue = value;
	}
	
	public XSCIntValue(String val) throws XSCException
	{
		try {
			fValue = Integer.parseInt(val);
		} catch (NumberFormatException e)
		{ throw new XSCException("Illegal Number Format: " + val,e); }
	}

	public int getType()
	{
		return XSCValue.INTEGER_VALUE;
	}

	public String getXMLString() throws XSCException
	{
		return Integer.toString(fValue);
	}
	
	public String getXSCString() throws XSCException
	{
		return Integer.toString(fValue);
	}

}
