package noown.domain.xsc.val;

import noown.domain.xsc.XSCException;
import noown.domain.xsc.XSCParserConstants;

import org.w3c.dom.Document;
import org.w3c.dom.NodeList;

/**
 * Class that holds a keyword value
 * 
 * @author Kilian Stillhard
 */
public class XSCKeywordValue extends XSCSimpleValue
{
	protected int fKeyword;
	
	public XSCKeywordValue(int keyword)
	{
		fKeyword = keyword;
	}

	public int getType()
	{
		return XSCValue.KEYWORD_VALUE;
	}
	
	public String getXMLString() throws XSCException
	{
		return getXSCString();
	}

	public String getXSCString() throws XSCException
	{
		String tok;
		// retrieve image of token, strip quotes
		try {
			tok = XSCParserConstants.tokenImage[fKeyword];
		} catch (ArrayIndexOutOfBoundsException e)
		{
			throw new XSCException("Illegal keyword number " + fKeyword + "!");
		}
		if (tok.charAt(0) == '"')
			tok = tok.substring(1,tok.length()-1);		
			
		return tok;
	}
	
	public boolean equals(XSCKeywordValue key)
	{
		return (fKeyword == key.fKeyword);
	}
	
	public int getKey()
	{
		return fKeyword;
	}
}
