package noown.domain.xsc.val;

import org.apache.xerces.dom.DocumentImpl;
import org.w3c.dom.Document;
import org.w3c.dom.NodeList;

import noown.domain.xsc.XSCException;

/**
 * Base class of all value and component classes.
 * 
 * Langbeschreibung
 * 
 * @author Kilian Stillhard
 * @version 0.01
 */
abstract public class XSCValue
{
	
	//Constants: Simple Value Types
	
	public static final int NAME_VALUE     = 0;	
	public static final int STRING_VALUE   = 1;
	public static final int KEYWORD_VALUE  = 2;
	public static final int INTEGER_VALUE  = 3;
	public static final int OCCSPEC_VALUE  = 4;
	public static final int INTRANGE_VALUE = 5;
	public static final int RANGE_VALUE    = 6;
	public static final int PATTERN_VALUE  = 7;
	public static final int XPATH_VALUE    = 8;
	public static final int URI_VALUE      = 9;
	public static final int ANNOT_VALUE    = 10;
	
	//Constants: Component Types
	
	public static final int COMPLEX_TYPE    = 100;
	public static final int SIMPLE_TYPE     = 101;
	public static final int RESTRICTION     = 102;
	public static final int UNION           = 103;
	public static final int LIST            = 104;
	public static final int ELEMENT         = 105;
	public static final int ATTRIBUTE       = 106;
	public static final int GROUP           = 107;
	public static final int ATTRIBUTE_GROUP = 108;
	public static final int ELEMENT_WC      = 109;
	public static final int ATTRIBUTE_WC    = 110;
	public static final int NOTATION        = 111;
	public static final int CONTENT_MODEL   = 112;
	public static final int MODEL_GROUP     = 113;
	public static final int KEY             = 114;
	public static final int KEYREF          = 115;
	public static final int UNIQUE          = 116;
	
	public static final int TARGET_NAMESPACE = 120;
	public static final int NAMESPACE        = 121;
	public static final int DEFAULT          = 122;
	public static final int DEFAULT_EL       = 123;
	public static final int DEFAULT_ATTR     = 124;
	public static final int VERSION          = 125;
	
	public static final int IMPORT          = 126;
	public static final int INCLUDE         = 127;
	public static final int REDEFINE        = 128;
	
	public static final int LENGTH_FACET    = 129;
	public static final int PATTERN_FACET   = 130;
	public static final int RANGE_FACET     = 131;
	public static final int ENUM_FACET      = 132;
	public static final int WHITESP_FACET   = 133;
	public static final int TOTDIG_FACET    = 134;
	public static final int FRACDIG_FACET   = 135;
	
	public static final int SCHEMA          = 150;
	
	abstract public int getType();
}
